/*
 * This ESP8266 NodeMCU code was developed by newbiely.com
 *
 * This ESP8266 NodeMCU code is made available for public use without any restriction
 *
 * For comprehensive instructions and wiring diagrams, please visit:
 * https://newbiely.com/tutorials/esp8266/esp8266-control-led-via-bluetooth
 */

#include <SoftwareSerial.h>
#define SOFT_RX 5  // The ESP8266 pin connected to the TX of the bluetooth module
#define SOFT_TX 4  // The ESP8266 pin connected to the RX of the bluetooth module
#define RELAY1 0
#define RELAY2 2
#define RELAY3 14
#define RELAY4 12

int changeVal = 0;   //if cangeVal = "1", relay1on = HIGH; relay1off = LOW; else relay1on = LOW; relay1off = HIGH
//It is useful if you use commercial a relay, which inverted state.
int relay1on;
int relay1off;
int relay2on;
int relay2off;
int relay3on;
int relay3off;
int relay4on;
int relay4off;
int value1;
int value2;
int value3;
int value4;

SoftwareSerial bluetooth(SOFT_RX, SOFT_TX);

void setup() {
  Serial.begin(9600);
  bluetooth.begin(9600);

  if (changeVal == 1){ 
    relay1on = 1;      
    relay1off = 0;
    relay2on = 1;
    relay2off = 0;
    relay3on = 1;      
    relay3off = 0;
    relay4on = 1;
    relay4off = 0;
  }    
  else{                
    relay1on = 0;
    relay1off = 1;  
    relay2on = 0;
    relay2off = 1; 
    relay3on = 0;
    relay3off = 1;  
    relay4on = 0;
    relay4off = 1; 
  }
value1 = relay1off;
value2 = relay2off;
value3 = relay3off;
value4 = relay4off;
  
  pinMode(RELAY1, OUTPUT); // Configure the ESP8266 pin as a digital output pin
  digitalWrite(RELAY1, relay1off);  
  pinMode(RELAY2, OUTPUT);
  digitalWrite(RELAY2, relay2off);  
  pinMode(RELAY3, OUTPUT);
  digitalWrite(RELAY3, relay3off);  
  pinMode(RELAY4, OUTPUT);
  digitalWrite(RELAY4, relay4off);  
}

void loop() {
  if (bluetooth.available())  { // if there is data comming
    String command = bluetooth.readStringUntil('\n'); // read string until meet newline character

    if ((command == "1 OFF") || (command == "1 off")){
      digitalWrite(RELAY1, relay1off);  // turn off relay
      bluetooth.println("RELAY1 is turned OFF"); // reports action to smartphone app
      Serial.print("RELAY1 is turned OFF");
    } else if ((command == "1 ON") || (command == "1 on")) {
      digitalWrite(RELAY1, relay1on); // turn on relay
      bluetooth.println("RELAY1 is turned ON"); // reports action to smartphone app
      Serial.print("RELAY1 is turned ON");
    }
        if ((command == "2 OFF") || (command == "2 off")){
      digitalWrite(RELAY2, relay2off);  // turn off relay
      bluetooth.println("LED2 is turned OFF"); // reports action to smartphone app
      Serial.print("LED2 is turned OFF");
    } else if ((command == "2 ON") || (command == "2 on")) {
      digitalWrite(RELAY2, relay2on); // turn on relay
      bluetooth.println("LED2 is turned ON"); // reports action to smartphone app
      Serial.print("LED2 is turned ON");
    }
       if ((command == "3 OFF") || (command == "3 off")){
      digitalWrite(RELAY3, relay3off);  // turn off relay
      bluetooth.println("LED3 is turned OFF"); // reports action to smartphone app
      Serial.print("LED3 is turned OFF");
    } else if ((command == "3 ON") || (command == "3 on")) {
      digitalWrite(RELAY3, relay3on); // turn on relay
      bluetooth.println("LED3 is turned ON"); // reports action to smartphone app
      Serial.print("LED3 is turned ON");
    }
      if ((command == "4 OFF") || (command == "4 off")){
      digitalWrite(RELAY4, relay4off);  // turn off relay
      bluetooth.println("LED4 is turned OFF"); // reports action to smartphone app
      Serial.print("LED4 is turned OFF");
    } else if ((command == "4 ON") || (command == "4 on")) {
      digitalWrite(RELAY4, relay4on); // turn on relay
      bluetooth.println("LED4 is turned ON"); // reports action to smartphone app
      Serial.print("LED4 is turned ON");
    }
     if ((command == "14 OFF") || (command == "14 off")){
      digitalWrite(RELAY1, relay1off);
      digitalWrite(RELAY2, relay2off);     
      digitalWrite(RELAY3, relay3off);  // turn off relay
      digitalWrite(RELAY4, relay4off);
      bluetooth.println("RELAY1/2/3/4 are turned OFF"); // reports action to smartphone app
      Serial.print("RELAY1/2/3/4 are turned OFF");
    } else if ((command == "14 ON") || (command == "14 on")) {
      digitalWrite(RELAY1, relay1on);
      digitalWrite(RELAY2, relay2on);      
      digitalWrite(RELAY3, relay3on); // turn on relay
      digitalWrite(RELAY4, relay4on);
      bluetooth.println("RELAY1/2/3/4 are turned ON"); // reports action to smartphone app
      Serial.print("RELAY1/2/3/4 are turned ON");
    }
     if ((command == "14 SOFF") || (command == "14 soff")){
      digitalWrite(RELAY4, relay4off);
      delay(250);
      digitalWrite(RELAY3, relay3off);
      delay(250);
      digitalWrite(RELAY2, relay3off);  
      delay(250);   
      digitalWrite(RELAY1, relay1off);  // turn off relay
      bluetooth.println("RELAY1/2/3 are turned OFF"); // reports action to smartphone app
      Serial.print("RELAY1/2/3/4 are turned OFF");
    } else if ((command == "14 SON") || (command == "14 son")) {
      digitalWrite(RELAY1, relay1on);
      delay(250);
      digitalWrite(RELAY2, relay2on);    
      delay(250);  
      digitalWrite(RELAY3, relay3on); // turn on relay
      delay(250);
      digitalWrite(RELAY4, relay4on); 
      bluetooth.println("RELAY1/2/3/4 are turned ON"); // reports action to smartphone app
      Serial.print("RELAY1/2/3/4 are turned ON");
    }
  }
}
